Sequel.migration do
  change do
    create_table :mailinglists do
      primary_key :id
      column :name,                  String, null: false # Name to display
      column :email,                 String, null: false # Mailing list email
      column :count_handled,         Integer  # amount of email distributed
      column :count_distributed,     Integer  # amount of email distributed
      column :last_email,            DateTime # date of last distribution
      column :strategy,              String, null: false # "free/validated/closed/..."
      column :updated_at,            DateTime
      column :created_at,            DateTime

      index :name, unique: true
      index :email, unique: true
    end
  end
end
